################################################################################
# Desc:   Named functions for awk
# Author: Ken Grimes
# Date:   2016
################################################################################
# This makefile consists of awk programs that may come in handy as an extension
# to the basic lisp make capabilities without having to invoke guile
################################################################################

# AWK_REVERSE_SQUASH############################################################
# The following awk program reverses the order of a list while also removing
# duplicate entries.  The effect of this when run on the dependency tree is that
# it will remove duplicates occurring in reverse order, allowing the most deeply
# nested libraries to be built, and linked, first. #############################
define AWK_REVERSE_SQUASH =
awk \
'
{ for(i=NF;i>0;i--)
    if (!a[$$i]++)
      print $$i
}
'
#/AWK_REVERSE_SQUASH############################################################
endef
