/* Ragel State Machine for tokenizing text */
#include <stdio.h>
#include <string.h>
#include <apc/parser.tab.h>


extern void lexer_pushtok(int, YYSTYPE);
//extern char* scanner_current_file();
extern int lexer_ismapfile(const char*, int);
extern int lexer_tokfile(const char*, int);


int lexer_lex(const char*);
int ipow(int, int);
int ttov(const uint8_t* , int);
uint64_t ttor(const uint8_t* , int);
char* ttos(const uint8_t* , int);


#define MAX_TOK_LEN 64
#define MAX_TOKENS 16
#define MAX_STR_SIZE (MAX_TOK_LEN * MAX_TOKENS)

/* Scan filename and push the its tokens
   onto the stack */
int lexer_lex (const char* str)
{
  int ntok, len;


  len = strlen(str);
  printf("Calling lexer_lex on %s\n", str);
  
  
  return ntok;
}

int ipow(int base, int exp)
{
  int result = 1;
  while (exp)
    {
      if (exp & 1)
        result = result * base;
      exp = exp >> 1;
      base *= base;
    }

  return result;
}

/*  Token to Value */
int ttov(const uint8_t* str, int len)
{
  int i, val = 0;

  for (i = 0; i < len; i++)
    {
      val += ((str[len - (i + 1)] - '0') * ipow(10,i));
    }

  return val;
}

uint64_t ttor(const uint8_t* str, int len)
{
  int i;
  uint64_t num = 0;

  for (i = 0; i < len; i++)
    {
      num += ((str[len - (i + 1)] - '0') * ipow(10,i));
    }

  return num;
}

char* ttos(const uint8_t* str, int len)
{
  int i;
  char token_buf[MAX_TOK_LEN];

  memmove(token_buf, str, len);
  token_buf[len+1] = '\0';

  return strdup(token_buf);
}
